#!/usr/bin/perl

# mapcheck.pl
# Dieses Script prüft die Zuordnungsdatei (/srv/sensor/map) auf Fehler.
# Scott-Falk Hühn, 05.06.2018

use strict;
use warnings;

my $mapdir = "/srv/sensor"; # Verzeichnis für Zuordnungsdatei
my $MAP;                    # Dateihandle der Zuordnungsdatei
my @mlist;                  # Zwischenspeicher für die Zuordnungsdatei
my $senum;                  # empfangene Sensornummer
my $i;                      # Zählervariable
my $j;	                    # Zählervariable
my $k;                      # Zählervariable
my $f;                      # Fehlerzähler
my $m;                      # Zwischenspeicher

if (open($MAP,"<$mapdir/map")) {
    @mlist = <$MAP>;
    close($MAP);
    $f = 0;
    if (scalar(@mlist) == 27) {
        for ($i = 1; $i < 25; $i ++) {
            $m = $mlist[$i - 1];
            chomp($m);
            if ($m =~ /^\d+?$/) {
                if (($m < 1) || ($m > 24)) {
                    $f ++;
                    print "Fehler in Zeile $i: keine gültige Nummer.\n";
                }
            }
            else {
                $f ++;
                print "Fehler in Zeile $i: keine gültige Nummer.\n";
            }
        }
        for ($i = 25; $i < 28; $i ++) {
            $m = $mlist[$i - 1];
            chomp($m);
            if ($m =~ /^\d+?$/) {
                if (($m < 25) || ($m > 27)) {
                    $f ++;
                    print "Fehler in Zeile $i: keine gültige Nummer.\n";
                }
            }
            else {
                $f ++;
                print "Fehler in Zeile $i: keine gültige Nummer.\n";
            }
        }
        for ($i = 1; $i < 25; $i ++) {
            $k = 0;
            for ($j = 0; $j < 24; $j ++) {
                $m = $mlist[$j];
                chomp($m);
                if ($m =~ /^\d+?$/) {
                    if ($i == $m) { $k ++; }
                }
            }
            if ($k < 1) {
                $f ++;
                print "Fehler in Teil 1: Die Nummer $i wird nicht verwendet.\n";
            }
            if ($k > 1) {
                $f ++;
                print "Fehler in Teil 1: Die Nummer $i wird mehrfach verwendet.\n";
            }
        }
        for ($i = 25; $i < 28; $i ++) {
            $k = 0;
            for ($j = 24; $j < 27; $j ++) {
                $m = $mlist[$j];
                chomp($m);
                if ($m =~ /^\d+?$/) {
                    if ($i == $m) { $k ++; }
                }
            }
            if ($k < 1) {
                $f ++;
                print "Fehler in Teil 2: Die Nummer $i wird nicht verwendet.\n";
            }
            if ($k > 1) {
                $f ++;
                print "Fehler in Teil 2: Die Nummer $i wird mehrfach verwendet.\n";
            }
        }
    }
    else {
        $f ++;
        print "Fehler: Die Zuordnungsdatei ist nicht 27 Zeilen lang.\n";
    }
    if ($f == 0) { print "Die Zuordnungsdatei $mapdir/map ist in Ordnung.\n"; }
}
else { print "Die Zuordnungsdatei $mapdir/map nicht vorhanden.\n"; }
