#!/usr/bin/perl

# /usr/local/bin/senupdate.pl
# Dieses Programm schreibt die aktuellen Sensorwerte in die Datenbank. Über folgenden Eintrag in der cron-Tabelle
# "0,15,30,45 * * * * perl /usr/local/bin/senupdate.pl" wird das Programm alle 15 Minuten aufgerufen.
# Scott-Falk Hühn, 28.12.2021

use strict;
use warnings;
use RRDs;

my $sendir = "/mnt/ram";    # Verzeichnis für Sensor- und Alarmdaten (flüchtige RAM-Disk)
my $rrddir = "/srv/sensor"; # Verzeichnis für die Datenbank (nichtflüchtige SD-Karte)
my $rrdname = "sensor.rrd"; # Name der Datenbank
my $SE;                     # Dateihandle einer Sensordatei
my $seval;                  # Sensorwert
my $i;                      # Zählervariable
my $vals;                   # zusammengefasste Werte
my $time;                   # aktuelle Zeit

$time = time();                                   # aktuelle Zeit holen
$vals = "";                                       # Werteliste für Datenbank löschen
for ($i = 1; $i < 32; $i++) {                     # 31 Sensorwerte bearbeiten
  $seval = 'U';                                   # Sensorwert ist zunächst ungültig
  if (open($SE, "<$sendir/s$i")) {                # Sensordatei öffnen
    $seval = <$SE>;                               # Sensorwert auslesen
    $seval =~ s/^\s+|\s+$//g;                     # Steuerzeichen aus Sensorwert entfernen
    close($SE);                                   # Sensordatei schließen
    if ((time - (stat "$sendir/s$i")[9]) > 120) { # wenn Erstellungszeit mehr als 2 min in der Vergangenheit
      $seval = 'U';                               # Wert ungültig setzen
    }
  }
  $vals = $vals . ":" . $seval;                   # Sensorwerte zusammenfassen
}
RRDs::update ("$rrddir/$rrdname", "$time$vals");  # Sensorwerte in RRD-Tool-Datenbank schreiben
