<!doctype html>
<html lang="de">
<head>
  <?php include 'title.php'; ?>
  <meta charset="utf-8">
  <meta name="author" content="Scott Falk Hühn">
  <meta name="editor" content="GNU nano 3.2">
  <meta name="robots" content="noindex">
  <meta name="date" content="2019-07-05">
  <link rel="shortcut icon" href="favicon.ico">
  <link rel="apple-touch-icon" href="icon.png">
  <link rel="apple-touch-icon-precomposed" href="icon.png">
  <link rel="stylesheet" href="style.css" type="text/css">
</head>
<body>
  <?php                                                   // Voreinstellungen bei Aufruf der Seite
    include 'menu.php';                                   // Menü einbinden
    $cfgdir  = "/srv/sensor";                             // Verzeichnis für Konfig-Daten
    $rrdfile = "/srv/sensor/sensor.rrd";                  // Datenbank
    $numpre  = 20;                                        // Anzahl der Presets
    $width   = 1000;                                      // Breite der Grafik (Außenmaß)
    $height  = 420;                                       // Höhe der Grafik (Außenmaß)
    $pres    = 0;                                         // zuletzt bearbeitetes Preset
    $perix   = 2;                                         // Zeitraumindex (0-9)
    $diff    = 0;                                         // Zeitdifferenz (für Vor- und Rück-Blättern)
    $yscal   = 0;                                         // Alternative Y-Skala (0-3)
    $line    = 2;                                         // Linienstärke (1-3)
    $snr1    = 1;                                         // Sensornummer Kurve 1 (1-31)
    $snr2    = 0;                                         // Sensornummer Kurve 2 (0-31)
    $snr3    = 0;                                         // Sensornummer Kurve 3 (0-31)
    $snr4    = 0;                                         // Sensornummer Kurve 4 (0-31)
    $col1    = "FF0000";                                  // Farbe für Kurve 1 (RRGGBB)
    $col2    = "008000";                                  // Farbe für Kurve 2 (RRGGBB)
    $col3    = "0000FF";                                  // Farbe für Kurve 3 (RRGGBB)
    $col4    = "FF00FF";                                  // Farbe für Kurve 4 (RRGGBB)
    $type1   = "AVERAGE";                                 // Datentyp Kurve 1 (AVERAGE, MIN, MAX)
    $type2   = "AVERAGE";                                 // Datentyp Kurve 2 (AVERAGE, MIN, MAX)
    $type3   = "AVERAGE";                                 // Datentyp Kurve 3 (AVERAGE, MIN, MAX)
    $type4   = "AVERAGE";                                 // Datentyp Kurve 4 (AVERAGE, MIN, MAX)
    $wdays   = array(                                     // Wochentage
      "So", "Mo", "Di", "Mi", "Do", "Fr", "Sa");
    $peri1   = array(                                     // Auswählbare Zeiträume, Texte
      "1 Tag", "2 Tage", "4 Tage", "1 Woche",
      "2 Wochen", "1 Monat", "2 Monate", "4 Monate",
      "6 Monate", "1 Jahr");
    $peri2   = array(                                     // Auswählbare Zeiträume, Zeitdaten
      "86400", "172800", "345600", "604800",
      "1209600", "2678400", "5356800", "10627200",
      "15897600", "31622400");

    function gsx($snum) {                                 // Prüfen, ob Sensor gesperrt ist
      global $cfgdir;
      $check = 1;                                         // Sensor zunächst freigeben
      if ($snum > 0 and $snum < 32) {                     // wenn gültige Sensornummer
        if (file_exists($cfgdir . "/s" . $snum)) {        // wenn Konfigurationsdatei vorhanden
          $sfile = fopen($cfgdir . "/s" . $snum, "r");    // Konfigurationsdatei öffnen
          $sread = fgets($sfile);                         // Sensorname überlesen
          $sread = fgets($sfile);                         // Unteren Grenzwert überlesen
          $sread = fgets($sfile);                         // Oberen Grenzwert überlesen
          $sread = rtrim(fgets($sfile, 10));              // Sperrvermerk lesen
          fclose($sfile);                                 // Konfigurationsdatei schließen
          if ($sread != 0) { $check = 0; }                // wenn Vermerk <> 0 -> sperren
        }
        else { $check = 0; }                              // wenn Konfigurationsdatei nicht vorhanden -> sperren
      }
      return $check;                                      // 0 = gesperrt, 1 = frei
    }

    function gsn($snum) {                                 // Sensorname übergeben
      global $cfgdir;
      $sname = "";
      if ($snum > 0 and $snum < 32) {                     // wenn gültige Sensornummer
        if (file_exists($cfgdir . "/s" . $snum)) {        // wenn Konfigurationsdatei vorhanden
          $sfile = fopen($cfgdir . "/s" . $snum, "r");    // Konfigurationsdatei öffnen
          $sname = htmlentities(rtrim(fgets($sfile, 100)), ENT_HTML5, "UTF-8"); // Sensorname holen
          fclose($sfile);                                 // und konvertieren
        }
        else { $sname = 'Fehler'; }                       // wenn Konfigurationsdatei nicht vorhanden -> Fehlertext
      }
      if ($snum == 0) { $sname = "aus"; }                 // wenn Sensornummer = 0 -> aus
      return $sname;
    }

    if (file_exists('last.dat')) {                        // wenn gespeicherte Einstellung vorhanden
      $lfile = fopen('last.dat', "r");
      $perix = rtrim(fgets($lfile, 12));                  // Zeitraumindex lesen
      $diff  = rtrim(fgets($lfile, 12));                  // Differenz lesen
      $snr1  = rtrim(fgets($lfile, 12));                  // Sensornummern lesen
      $snr2  = rtrim(fgets($lfile, 12));
      $snr3  = rtrim(fgets($lfile, 12));
      $snr4  = rtrim(fgets($lfile, 12));
      $type1 = rtrim(fgets($lfile, 12));                  // Datentypen lesen
      $type2 = rtrim(fgets($lfile, 12));
      $type3 = rtrim(fgets($lfile, 12));
      $type4 = rtrim(fgets($lfile, 12));
      $yscal = rtrim(fgets($lfile, 12));                  // Alternative Y-Skala lesen
      $line  = rtrim(fgets($lfile, 12));                  // Linienstärke lesen
      $pres  = rtrim(fgets($lfile, 12));                  // Presetnummer laden
      fclose($lfile);
    }

    if (isset($_POST['sent'])) {                          // wenn neue Einstellung gesendet
      $perix = $_POST['perix'];                           // Zeitraumindex übernehmen
      $diff  = $_POST['diff'];                            // Differenz übernehmen
      $snr1  = $_POST['snr1'];                            // Sensornummern übernehmen
      $snr2  = $_POST['snr2'];
      $snr3  = $_POST['snr3'];
      $snr4  = $_POST['snr4'];
      $type1 = $_POST['type1'];                           // Datentypen übernehmen
      $type2 = $_POST['type2'];
      $type3 = $_POST['type3'];
      $type4 = $_POST['type4'];
      $yscal = $_POST['yscal'];                           // Alternative Y-Skala übernehmen
      $line  = $_POST['line'];                            // Linienstärke übernehmen
    }

    if (isset($_POST['back'])) {                          // wenn Button "Zurück" gedrückt
      $diff = $diff - $peri2[$perix];                     // Differenz um Zeitraum vermindern
    }

    if (isset($_POST['forw'])) {                          // wenn Button "Vorwärts" gedrückt
      $diff = $diff + $peri2[$perix];                     // Differenz um Zeitraum erhöhen
    }

    if (isset($_POST['now'])) {                           // wenn Button "Aktuell" gedrückt
      $diff = 0;                                          // Differenzwert löschen
    }

    if (isset($_POST['prlo'])) {                          // wenn Button "Preset laden" gedrückt
      if (isset($_POST['prload'])) {                      // wenn gültige Preset-Nummer vorhanden
        $pres = $_POST['prload'];                         // Presetnummmer holen
        $pfile = fopen('preset' . $pres . '.dat', "r");   // Presetdatei öffnen
        $pname = fgets($pfile, 100);                      // Presetname überlesen
        $perix = rtrim(fgets($pfile, 12));                // Zeitraumindex lesen
        $snr1  = rtrim(fgets($pfile, 12));                // Sensornummern lesen
        $snr2  = rtrim(fgets($pfile, 12));
        $snr3  = rtrim(fgets($pfile, 12));
        $snr4  = rtrim(fgets($pfile, 12));
        $type1 = rtrim(fgets($pfile, 12));                // Datentypen lesen
        $type2 = rtrim(fgets($pfile, 12));
        $type3 = rtrim(fgets($pfile, 12));
        $type4 = rtrim(fgets($pfile, 12));
        $yscal = rtrim(fgets($pfile, 12));                // Alternative Y-Skala lesen
        $line  = rtrim(fgets($pfile, 12));                // Linienstärke lesen
        fclose($pfile);
        $diff  = 0;                                       // Differenz löschen
      }
    }

    if (isset($_POST['prsa'])) {                          // wenn Button "Preset speichern" gedrückt
      $pname = $_POST['prname'];                          // Presetname übernehmen
      $pres = $_POST['prsave'];                           // Presetnummer übernehmen
      $pfile = fopen('preset' . $pres . '.dat', "w");     // Presetdatei schreiben
      fwrite($pfile, $pname . "\n");                      // Presetname speichern
      fwrite($pfile, $perix . "\n");                      // Zeitraumindex speichern
      fwrite($pfile, $snr1 . "\n");                       // Sensornummern speichern
      fwrite($pfile, $snr2 . "\n");
      fwrite($pfile, $snr3 . "\n");
      fwrite($pfile, $snr4 . "\n");
      fwrite($pfile, $type1 . "\n");                      // Datentypen speichern
      fwrite($pfile, $type2 . "\n");
      fwrite($pfile, $type3 . "\n");
      fwrite($pfile, $type4 . "\n");
      fwrite($pfile, $yscal . "\n");                      // Alternative Y-Skala speichern
      fwrite($pfile, $line . "\n");                       // Linienstärke speichern
      fclose($pfile);
    }

    if (isset($_POST['prcl'])) {                          // wenn Button "Preset löschen" gedrückt
      $pres = $_POST['prsave'];                           // Presetnummer übernehmen
      if (file_exists('preset' . $pres . '.dat')) {       // wenn Presetdatei vorhanden
        unlink('preset' . $pres . '.dat');                // Presetdatei löschen
      }
      $pres = 0;                                          // Preset = 0 setzen
    }

    $start = - $peri2[$perix] + $diff;                    // neue Startzeit ermitteln
    $end   = $start + $peri2[$perix];                     // neue Endzeit ermitteln
    if ($end >= 0) {                                      // wenn Endzeit >= aktuelle Zeit (>=0)
      $end = 'now';                                       // Endzeit auf aktuelle Zeit setzen
      $start = - $peri2[$perix];                          // Startzeit korrigieren
      $diff = 0;                                          // Differenz löschen
    }

    $lfile = fopen('last.dat', "w");                      // Einstellungen speichern
    fwrite($lfile, $perix . "\n");                        // Zeitraumindex speichern
    fwrite($lfile, $diff . "\n");                         // Differenz speichern
    fwrite($lfile, $snr1 . "\n");                         // Sensornummern speichern
    fwrite($lfile, $snr2 . "\n");
    fwrite($lfile, $snr3 . "\n");
    fwrite($lfile, $snr4 . "\n");
    fwrite($lfile, $type1 . "\n");                        // Datentypen speichern
    fwrite($lfile, $type2 . "\n");
    fwrite($lfile, $type3 . "\n");
    fwrite($lfile, $type4 . "\n");
    fwrite($lfile, $yscal . "\n");                        // Alternative Y-Skala speichern
    fwrite($lfile, $line . "\n");                         // Linienstärke speichern
    fwrite($lfile, $pres . "\n");                         // Presetnummer speichern
    fclose($lfile);

    $graph1 = "s" . $snr1;                                // Kurve 1, Sensorname für Datenbank ermitteln
    if (file_exists($cfgdir . "/" . $graph1)) {           // wenn Konfigurationsdatei vorhanden
      $sfile = fopen($cfgdir . "/" . $graph1, "r");       // Konfigurationsdatei öffnen
      $sname1 = rtrim(fgets($sfile, 100));                // Sensorname holen
      fclose($sfile);                                     // Konfiguraionsdatei schließen
    }
    else { $sname1 = 'Fehler'; }                          // wenn Konfigurationsdatei nicht vorhanden -> Fehlertext
    $grset = array(                                       // Grafik-Grundeinstellungen für Kurve 1
      "-s$start",                                         // Startzeit
      "-e$end",                                           // Endzeit
      "-w$width",                                         // Breite der Grafik
      "-h$height",                                        // Höhe der Grafik
      "-A",                                               // Automatische Y-Skalierung
      "-X0",                                              // Exponent 0
      "-E",                                               // Weiche Kantendarstellung
      "-D",                                               // Breite und Höhe entspricht dem Außenmaß
      "TEXTALIGN:center",                                 // Texte in Legende zentrieren
      "DEF:var1=$rrdfile:$graph1:$type1",                 // Kurvenparameter 1
      "LINE$line:var1#$col1:$sname1",                     // Linienstärke, Farbe, Sensorname
      "GPRINT:var1:MIN:%.1lf",                            // Minimalwert in Legende
      "GPRINT:var1:MAX:%.1lf");                           // Maximalwert in Legende

    switch ($yscal) {                                     // Option für Alternative Y-Skala ergänzen
      case 0:
        array_push($grset, "-Y");                         // automatische Skalierung
        break;
      case 1:
        array_push($grset, "-y0.5:2");                    // Alternative Skala, Raster 0,5 / Einheit 1
        break;
      case 2:
        array_push($grset, "-y0.5:4");                    // Alternative Skala, Raster 0,5 / Einheit 2
        break;
      case 3:
        array_push($grset, "-y1:4");                      // Alternative Skala, Raster 1 / Einheit 4
        break;
    }

    if ($snr2 > 0) {                                      // wenn Kurve 2 aktiviert (Sensornummer > 0)
      $graph2 = "s" . $snr2;
      $sfile = fopen($cfgdir . "/" . $graph2, "r");       // Konfigurationsdatei öffnen
      $sname2 = rtrim(fgets($sfile, 100));                // Sensorname holen
      fclose($sfile);
      $grset = array_merge($grset, array(                 // Grafik-Einstellungen für Kurve 2 hinzufügen
        "DEF:var2=$rrdfile:$graph2:$type2",               // Kurvenparameter 2
        "LINE$line:var2#$col2:$sname2",                   // Linienstärke, Farbe, Sensorname
        "GPRINT:var2:MIN:%.1lf",                          // Minimalwert in Legende
        "GPRINT:var2:MAX:%.1lf"));                        // Maximalwert in Legende
    }

    if ($snr3 > 0) {                                      // wenn Kurve 3 aktiviert (Sensornummer > 0)
      $graph3 = "s" . $snr3;
      $sfile = fopen($cfgdir . "/" . $graph3, "r");       // Konfigurationsdatei öffnen
      $sname3 = rtrim(fgets($sfile, 100));                // Sensorname holen
      fclose($sfile);
      $grset = array_merge($grset, array(                 // Grafik-Einstellungen für Kurve 3 hinzufügen
        "DEF:var3=$rrdfile:$graph3:$type3",               // Kurvenparameter 3
        "LINE$line:var3#$col3:$sname3",                   // Linienstärke, Farbe, Sensorname
        "GPRINT:var3:MIN:%.1lf",                          // Minimalwert in Legende
        "GPRINT:var3:MAX:%.1lf"));                        // Maximalwert in Legende
    }

    if ($snr4 > 0) {                                      // wenn Kurve 4 aktiviert (Sensornummer > 0)
      $graph4 = "s" . $snr4;
      $sfile = fopen($cfgdir . "/" . $graph4, "r");       // Konfigurationsdatei öffnen
      $sname4 = rtrim(fgets($sfile, 100));                // Sensorname holen
      fclose($sfile);
      $grset = array_merge($grset, array(                 // Grafik-Einstellungen für Kurve 4 hinzufügen
        "DEF:var4=$rrdfile:$graph4:$type4",               // Kurvenparameter 4
        "LINE$line:var4#$col4:$sname4",                   // Linienstärke, Farbe, Sensorname
        "GPRINT:var4:MIN:%.1lf",                          // Minimalwert in Legende
        "GPRINT:var4:MAX:%.1lf"));                        // Maximalwert in Legende
    }

    rrd_graph("graph.png", $grset);                       // Grafik erzeugen
  ?>
  <p>
    <img src="graph.png?<?php echo time(); ?>" alt="Grafik">
  </p>

  <form name="Eingabe" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>" method="post">
    <fieldset style="width:720px">
      <select name="prload" size="1" class="gr1">
        <?php
          for ($i = 0; $i < $numpre; $i ++) {
            if (file_exists('preset' . $i . '.dat')) {
              $pfile = fopen('preset' . $i . '.dat', "r");
              $pname = rtrim(fgets($pfile, 100));
              fclose($pfile);
              echo '<option ';
              if ($pres == $i) { echo 'selected '; }
              echo 'value="' . $i . '">' . $pname . "</option>\n";
            }
          }
        ?>
      </select>
      <input type="submit" value="Preset laden" name="prlo">
    </fieldset>

    <fieldset style="width:720px">
      <span class="gr2">Zeitraum</span>
      <select name="perix" size="1" class="gr2">
        <?php
          for ($i = 0; $i < count($peri1); $i ++) {
            echo '<option ';
            if ($perix == $i) { echo 'selected '; }
            echo 'value="' . $i . '">' . $peri1[$i] . '</option>' . "\n";
          }
        ?>
      </select>
      <span class="gr2">
        <?php
          echo $wdays[date("w", time() + $start)] . date(", d.m.Y", time() + $start) . ' - ';
          if ($end == 'now') { echo $wdays[date("w", time())] . date(", d.m.Y", time()); }
          else { echo $wdays[date("w", time() + $end)] . date(", d.m.Y", time() + $end); }
        ?>
      </span>
      <span style="margin-left:50px">
        <input type="submit" value="OK" name="ok" style="margin-right:20px">
        <input type="submit" value="&lt;" name="back">
        <input type="submit" value="&gt;" name="forw">
        <input type="submit" value="&gt;&gt;" name="now">
      </span>
      <br style="clear:both">

      <div style="float:left; margin-right:10px">
        <span class="gr2" style="color:#<?php echo $col1; ?>">Kurve 1</span>
        <select name="snr1" size="1" class="gr2">
          <?php
            for ($i = 1; $i < 32; $i ++) {
              if (gsx($i)) {
                echo '<option ';
                if ($snr1 == $i) { echo 'selected '; }
                echo 'value="'. $i . '">' . gsn($i) . '</option>' . "\n";
              }
            }
          ?>
        </select>
        <select name="type1" size="1" class="gr2">
          <option <?php if ($type1 == "AVERAGE") { echo 'selected '; } ?>value="AVERAGE">Mittelwert</option>
          <option <?php if ($type1 == "MIN") { echo 'selected '; } ?>value="MIN">Minimalwert</option>
          <option <?php if ($type1 == "MAX") { echo 'selected '; } ?>value="MAX">Maximalwert</option>
        </select>
        <br style="clear:both">

        <span class="gr2" style="color:#<?php echo $col2; ?>">Kurve 2</span>
        <select name="snr2" size="1" class="gr2">
          <?php
            for ($i = 0; $i < 32; $i ++) {
              if (gsx($i)) {
                echo '<option ';
                if ($snr2 == $i) { echo 'selected '; }
                echo 'value="'. $i . '">' . gsn($i) . '</option>' . "\n";
              }
            }
          ?>
        </select>
        <select name="type2" size="1" class="gr2">
          <option <?php if ($type2 == "AVERAGE") { echo 'selected '; } ?>value="AVERAGE">Mittelwert</option>
          <option <?php if ($type2 == "MIN") { echo 'selected '; } ?>value="MIN">Minimalwert</option>
          <option <?php if ($type2 == "MAX") { echo 'selected '; } ?>value="MAX">Maximalwert</option>
        </select>
        <br style="clear:both">

        <span class="gr2" style="color:#<?php echo $col3; ?>">Kurve 3</span>
        <select name="snr3" size="1" class="gr2">
          <?php
            for ($i = 0; $i < 32; $i ++) {
              if (gsx($i)) {
                echo '<option ';
                if ($snr3 == $i) { echo 'selected '; }
                echo 'value="'. $i . '">' . gsn($i) . '</option>' . "\n";
              }
            }
          ?>
        </select>
        <select name="type3" size="1" class="gr2">
          <option <?php if ($type3 == "AVERAGE") { echo 'selected '; } ?>value="AVERAGE">Mittelwert</option>
          <option <?php if ($type3 == "MIN") { echo 'selected '; } ?>value="MIN">Minimalwert</option>
          <option <?php if ($type3 == "MAX") { echo 'selected '; } ?>value="MAX">Maximalwert</option>
        </select>
        <br style="clear:both">

        <span class="gr1" style="color:#<?php echo $col4; ?>">Kurve 4</span>
        <select name="snr4" size="1" class="gr1">
          <?php
            for ($i = 0; $i < 32; $i ++) {
              if (gsx($i)) {
                echo '<option ';
                if ($snr4 == $i) { echo 'selected '; }
                echo 'value="'. $i . '">' . gsn($i) . '</option>' . "\n";
              }
            }
          ?>
        </select>
        <select name="type4" size="1" class="gr1">
          <option <?php if ($type4 == "AVERAGE") { echo 'selected '; } ?>value="AVERAGE">Mittelwert</option>
          <option <?php if ($type4 == "MIN") { echo 'selected '; } ?>value="MIN">Minimalwert</option>
          <option <?php if ($type4 == "MAX") { echo 'selected '; } ?>value="MAX">Maximalwert</option>
        </select>
      </div>

      <fieldset style="margin-right:1px; margin-top:20px">
        <span class="gr2">Alternative Y-Skala</span>
        <select name="yscal" size="1" class="gr2">
          <option <?php if ($yscal == 0) { echo 'selected '; } ?>value="0">aus</option>
          <option <?php if ($yscal == 1) { echo 'selected '; } ?>value="1">1</option>
          <option <?php if ($yscal == 2) { echo 'selected '; } ?>value="2">2</option>
          <option <?php if ($yscal == 3) { echo 'selected '; } ?>value="3">3</option>
        </select>
        <br style="clear:both">
        <span class="gr1">Linienstärke (Pixel)</span>
        <select name="line" size="1" class="gr1">
          <option <?php if ($line == 1) { echo 'selected '; } ?>value="1">1</option>
          <option <?php if ($line == 2) { echo 'selected '; } ?>value="2">2</option>
          <option <?php if ($line == 3) { echo 'selected '; } ?>value="3">3</option>
        </select>
      </fieldset>
    </fieldset>

    <fieldset style="width:720px">
      <input type="text" size="50" maxlength="100" name="prname" value="Presetname eingeben, Presetplatz wählen"
        class="gr2">
      <select name="prsave" size="1" class="gr1">
        <?php
          for ($i = 0; $i < $numpre; $i ++) {
            if (file_exists('preset' . $i . '.dat')) {
              $pfile = fopen('preset' . $i . '.dat', "r");
              $pname = rtrim(fgets($pfile, 100));
              fclose($pfile);
            }
            else { $pname = 'leer'; }
            echo '<option ';
            if ($pres == $i) { echo 'selected '; }
            echo 'value="' . $i . '">' . $pname . "</option>\n";
          }
        ?>
      </select>
      <br style="clear:both">
      <span style="float:left">
        <input type="submit" value="Preset speichern" name="prsa">
        <input type="submit" value="Preset löschen" name="prcl">
      </span>
    </fieldset>
    <input type="hidden" value="<?php echo $diff; ?>" name="diff">
    <input type="hidden" value="1" name="sent">
  </form>
</body>
</html>
