<!doctype html>
<html lang="de">
<head>
  <?php include 'title.php'; ?>
  <meta charset="utf-8">
  <meta name="author" content="Scott Falk Hühn">
  <meta name="editor" content="GNU nano 2.7.4">
  <meta name="robots" content="noindex">
  <meta name="date" content="2018-06-04">
  <link rel="shortcut icon" href="favicon.ico">
  <link rel="apple-touch-icon" href="icon.png">
  <link rel="apple-touch-icon-precomposed" href="icon.png">
  <link rel="stylesheet" href="style.css" type="text/css">
</head>
<body>
  <?php
    include 'menu.php';
    $width   = 861;
    $height  = 100;
    $infile  = "/srv/sensor/system.rrd";
    $disp = array(
      "-w$width",
      "-h$height",
      "-s-5h",
      "-tCPU-Auslastung (5 Stunden)",
      "TEXTALIGN:center",
      "-vAuslastung",
      "-l0",
      "-u0.5",
      "-X0",
      "DEF:cpuavg=$infile:cpu:AVERAGE",
      "DEF:cpumin=$infile:cpu:MIN",
      "DEF:cpumax=$infile:cpu:MAX",
      "AREA:cpuavg#ffb000:CPU-Auslastung",
      "GPRINT:cpumin:MIN:%.2lf",
      "GPRINT:cpuavg:AVERAGE:%.2lf",
      "GPRINT:cpumax:MAX:%.2lf",
    );
    rrd_graph("cpuload-hou.png", $disp);
    $disp = array(
      "-w$width",
      "-h$height",
      "TEXTALIGN:center",
      "-vAuslastung",
      "-l0",
      "-u0.5",
      "-X0",
      "DEF:cpuavg=$infile:cpu:AVERAGE",
      "DEF:cpumin=$infile:cpu:MIN",
      "DEF:cpumax=$infile:cpu:MAX",
      "CDEF:cpudif=cpumax,cpuavg,-",
      "LINE2:cpuavg#000000",
      "AREA:cpudif#ffb000:CPU-Auslastung:STACK",
      "LINE2:cpuavg#000000",
      "GPRINT:cpumin:MIN:%.2lf",
      "GPRINT:cpuavg:AVERAGE:%.2lf",
      "GPRINT:cpumax:MAX:%.2lf",
    );
    $graph2 = array("-s-2d", "-tCPU-Auslastung (2 Tage)");
    $graph3 = array("-s-30d", "-tCPU-Auslastung (30 Tage)");
    rrd_graph("cpuload-day.png", array_merge($graph2, $disp));
    rrd_graph("cpuload-mon.png", array_merge($graph3, $disp));
  ?>
  <p>
    <img src="cpuload-hou.png" style="margin-bottom:4px" alt="Grafik 1"> <br style="clear:both">
    <img src="cpuload-day.png" style="margin-bottom:4px" alt="Grafik 2"> <br style="clear:both">
    <img src="cpuload-mon.png" style="margin-bottom:4px" alt="Grafik 3"> <br style="clear:both">
  </p>
</body>
</html>
